﻿/********************************************************************************/
/* 	gamecore.d																	*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2011/04/15														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/04/15	tamakoroベースに作成開始	2008/05/22	tamakoro 初版をベース	*/
/*	2011/04/30	ver 1.00リリース												*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

private import state;
private import hell2;
private import boot;
private import actor;
private import vector;
private import keypad;
private import clickable;
//private import configparser;

import config;

//private import std.math;

/********************************************************************************/

//ConfigParser configparser = null;
const static string CONFIG_PATH = "config.ini";


/* GameMain *********************************************************************/
/*	ゲーム本体の状態															*/
/********************************************************************************/

class GameMain : GameState
{
public:
	//-----------------------------------------------------------------------------
	//システム制御用     #00A変数設定はここ～
	//-----------------------------------------------------------------------------
	enum SCENE{
		INIT = 0,
		START,
		MAIN,
		CLEAR,
		END,
		PAUSE,
		RELESE,
		
		//以下ゲーム内の演出
		PLAYER_WARP,
		ENEMY_GETWAIT,
		PLAYER_MISSWAIT,

		EXIT,
	};
	

	ConfigParser savedata;			// セーブデータ

	int timer;						// 汎用タイマー
	SCENE iSceneStatus;				//画面の状態
	int stage;						// ステージ
	int stage_start_count;			// ステージ開始処理
	int stage_clear_count;			// ステージ開始処理
	int menu_input = 0;				//敵を倒したときのWAITカウンタ

	int mode; 						//ゲームのモード
	int hi_score[10] = 0;			//ハイスコア
	int game_score = 0;				//スコア
	int game_time_count = 0;		//ゲーム終了までの残り時間
	int field_x = 50;				//表示位置
	int field_y = 50;				//表示位置
	int card_max = 6 * 10;			//カードの枚数 4色同数字2枚ずつで8枚×数字の種類 最大80まで
	int card_count = 0;				//取得カード数
	int cardlock1 = 99;				//1枚目
	int cardlock2 = 99;				//2枚目
	int game_end = 99;				//組みができないかのチェック
	int bonus = 0;					//基本点
	int bonus1 = 0;					//ペアボーナス
	int bonus_c = 0;				//colorコンボボーナス
	int bonus_n = 0;				//numberコンボボーナス
	int bonus_color = 0;			//ペアボーナス色系
	int bonus_signal = 0;			//ペアボーナス色系
	int bonus_number = 0;			//ペアボーナス数系
	int bonus_step = 0;				//ペアボーナス数系
	int bonus_8bit = 0;				//ペアボーナス数系
	int wait_time = 60*60*3;		//裏返し時間
	int bg_r = 0 ;					//背景色
	int bg_g = 0 ;					//背景色
	int bg_b = 100 ;				//背景色
	int bg_r2 = 0 ;					//背景色
	int bg_g2 = 0 ;					//背景色
	int bg_b2 = 100 ;				//背景色
	int effect_c[30] = 0 ;			//色bonusエフェクト用
	int effect_n[30] = 0 ;			//数bonusエフェクト用
	int effect_deg[30] = 0 ;		//エフェクト用角度
	int effect_count[30] =0 ;		//エフェクト用カウント

	
	struct UNIT	{
				 int type;						//色種類 0-3,4
				 int num;						//数字   0-9
				 float x;						//x座標
				 float y;						//y座標
				 int state;						//状態 0 free 1 lock 2-10 effect & erase
				 int deg;						//角度
				 float speed;					//速度
				 int wait;						//表示時間
				}
	UNIT card[100];

	Keypad keypad;					// キーボード/ゲームパッド取得用
	//-----------------------------------------------------------------------------
	//ゲーム別に使用される特別処理用変数
	//-----------------------------------------------------------------------------

	//-----------------------------------------------------------------------------
	//	コンストラクタ
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	this()
	{
		setMsg( GameState.MSG_NONE );
		// 各種初期化
		timer = 0;

		savedata          = new ConfigParser();
		keypad = new Keypad();
		keypad.SetUseCancel( false );

		iSceneStatus = SCENE.INIT;

	}

	
	//-----------------------------------------------------------------------------
	//	シーンの初期化     #01
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void init( )
	{
Hell_write( "Gamecoer init\n" );
		//リソースの読み込み
		Hell_loadTexture("tama","resource/image/tama.bmp" , [0,255,0]);

		Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);

		Hell_loadWAV("get",         "resource/sound/l1.wav");
		Hell_loadWAV("door",        "resource/sound/puwa.wav");
		Hell_loadWAV("miss",        "resource/sound/damage.wav");
		Hell_loadWAV("select",        "resource/sound/select.wav");
		Hell_loadWAV("cancel",        "resource/sound/puwa.wav");
		Hell_loadWAV("destroy",        "resource/sound/destroy2.wav");
		Hell_loadWAV("powerup",        "resource/sound/clear.wav");

		//セーブデータ
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         999999);
			savedata.set("HI_SCORE1",         999999);
			savedata.set("HI_SCORE2",         999999);
			savedata.set("HI_SCORE3",         999999);
			savedata.set("HI_SCORE4",         999999);
			savedata.set("HI_SCORE5",         999999);
			savedata.set("HI_SCORE6",         999999);
			savedata.set("HOSHI",         1);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE");
		hi_score[1] = savedata.getint("HI_SCORE1");
		hi_score[2] = savedata.getint("HI_SCORE2");
		hi_score[3] = savedata.getint("HI_SCORE3");
		hi_score[4] = savedata.getint("HI_SCORE4");
		hi_score[5] = savedata.getint("HI_SCORE5");
		hi_score[6] = savedata.getint("HI_SCORE6");

		game_time_count = 60*60*3;		//ゲーム終了までの残り時間
		mode = Hell_GetGameflag(10);	//ゲームモード

	//初期ステータス決定
	int j;
	int k;
	int r1;
	int r2;
	for ( j = 0; j <= card_max - 1; j++ )			//カードデータの初期化
	{
		card[j].type = (j / 10) % 3;				//色種類 0-3
		card[j].num =  j % 10 ;						//数字   0-9
//		card[j].type = (j / 2) % 3;					//色種類 0-3
//		card[j].num =  j / 6 % 10 ;					//数字   0-9
		card[j].x = 0 + (32 + 1) * ( j % 10 );		//x座標
		card[j].y = 50 + (j / 10) * (32 + 1);		//y座標
		card[j].state = 0;							//オープン状態 0-2 
//		card[j].deg =  Hell_randInt(0, 4) * 90;		//角度(90度固定)
		card[j].deg =  Hell_randInt(1, 360) ;		//角度(ランダム)
		card[j].speed = 0;							//速度
		card[j].wait = wait_time;					//裏返し時間
	
		//変化要素
//		card[j].speed = cast(float)Hell_randInt(10, 20)/10;		//速度


		
		if ( mode == 1 )	//LINE
		{
		}
		if ( mode == 2 )	//SHUFFLE
		{
		}
		if ( mode == 3 )	//MEMORY
		{
			wait_time = 60 * 30;						//30秒表を向く
			card[j].wait = wait_time;					//裏返し時間
		}
		if ( ( mode >= 4 ) && ( mode <= 6 ) )	//カードのランダム配置
		{
			card[j].x = Hell_randInt(0, 10)*32 + 5;		//x座標(碁盤の目)
			card[j].y = Hell_randInt(0, 10)*32 + 5;		//y座標
		}
		if ( mode == 4 )	//SQUARE
		{
		}
		if ( mode == 5 )	//MIXER
		{
			card[j].speed = cast(float)Hell_randInt(10, 20)/10;		//速度
		}
		if ( mode == 6 )	//REVERSE
		{
			wait_time = 60 * 30;						//30秒表を向く
			card[j].wait = wait_time;					//裏返し時間
		}
		
		
			for ( k = 0; k <= j; k++ )
			{
				if ( ( card[j].x - 32 < card[k].x ) && ( card[j].x + 32 > card[k].x )
				  && ( card[j].y - 32 < card[k].y ) && ( card[j].y + 32 > card[k].y ) && ( k != j )  )
				{
					//重なり座標再配置
					card[j].x = Hell_randInt(0, 10)*32 + 5;		//x座標(90度モード)
					card[j].y = Hell_randInt(0, 10)*32 + 5;		//y座標
//					card[j].x = Hell_randInt(0, 300) ;			//x座標
//					card[j].y = Hell_randInt(0, 300) ;			//y座標

					k = -1;										//0が重なる都合上-1でループリセットしている。
//				 	Hell_playWAV( "select", 0, -1 );
				}
			}
	}
		if ( ( mode >= 2 ) && ( mode <= 3 ) )	//SHUFFLE
		{
			for ( j = 0; j <= 200; j++ )					//40枚のカードデータのシャッフル
			{
				r1 = Hell_randInt(0, card_max);
				r2 = Hell_randInt(0, card_max);
				card[99].type = card[r1].type;						//色種類 0-3
				card[99].num =  card[r1].num;						//数字   0-9
				card[r1].type = card[r2].type;						//色種類 0-3
				card[r1].num =  card[r2].num;						//数字   0-9
				card[r2].type = card[99].type;						//色種類 0-3
				card[r2].num =  card[99].num;						//数字   0-9
			}
		}
		//コンボ用のダミーデータ
		card[91].type = 5;
		card[92].type = 5;
		card[93].type = 5;
		card[91].num = 999;
		card[92].num = 999;
		card[93].num = 999;


		
Hell_write( "Gamecoer init\n" );

		iSceneStatus = SCENE.START;
	}
	


	//-----------------------------------------------------------------------------
	//	シーンの後処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void relese( )
	{
		iSceneStatus = SCENE.EXIT;
	}
	//-----------------------------------------------------------------------------
	//	開始演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_move( )
	{
		int i;

		if ( stage_start_count < ( 60 * 3 ) )
		{
			stage_start_count++;
		}
		else 
		{
			Hell_playBgm( "resource/sound/bgm_mogmog.ogg", -1, 0 );
			iSceneStatus = SCENE.MAIN;
			stage_start_count = 0;
		}
	}
	//-----------------------------------------------------------------------------
	//	ステージ開始表示処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneStart_draw( )
	{
		if ( stage_start_count > ( 60 * 2 ) )
		{
			Hell_drawFont(" GO! " , 155, 200 , 4 , 255,255,255);
		}
		else
		{
			Hell_drawFont("READY" , 150, 200 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の処理
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_move( )
	{
		if ( stage_clear_count > ( 60 * 2 ) )
		{
			if(Hell_isPushMouse() & HELL_BUTTON_LEFT)
			{
				iSceneStatus = SCENE.RELESE;
			}
		}
		else 
		{
			stage_clear_count++;
		}
		
		
	}
	//-----------------------------------------------------------------------------
	//	クリア演出の表示
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneClear_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;

		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "RESULTS" , 110, 160 , 4 , 255,255,255);
		Hell_drawFont( "SCORE" ,    175, 200 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 140, 230 , 4 , 255,255,255);
		if ( hi_score[mode] <= game_score )
		{
			Hell_drawFont( " NEW RECORD ",75, 280 , 3 , 255,50,50);
			star_draw( Hell_randInt(0, 250) + 75 -50 , Hell_randInt(0, 40) + 280 -60 , Hell_randInt(10, 30) , Hell_randInt(0, 360));
		}

		if ( stage_clear_count > ( 60 * 2 ) )
		{
			Hell_drawFont("PRESS mouse L BUTTON TO EXIT" , 100, 440 , 2 , 255,255,255);
		}
		else
		{
//			Hell_drawFont(" OWARI !" , 200, 420 , 4 , 255,255,255);
		}
	}
	//-----------------------------------------------------------------------------
	//	ゲームオーバー演出
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void SeneEnd( )
	{
//		iSceneStatus = SCENE.MAIN;
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの動作
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void move()
	{
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			init( );
			break;
		case SCENE.START:
			//開始
			SeneStart_move( );
			break;
		case SCENE.MAIN:
			keypad.update( );	//リプレイキー入力の更新
			//メイン
			system_move( );

			break;
		case SCENE.CLEAR:
			//クリア
//			effect_move( );
//			mob_move( );
			SeneClear_move( );
			break;
		case SCENE.END:
			//ゲームオーバー
			break;
		case SCENE.PAUSE:
			//一時停止
			pause_move( );
			break;
		case SCENE.RELESE:
			//後処理
			relese( );
			break;

		case SCENE.EXIT:
		default:
			//シーンの終了
			setMsg(GameState.MSG_REQ_TITLE);
			break;
		}
	}
	
	//-----------------------------------------------------------------------------
	//	オブジェクトの描画
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void draw()
	{
		// 作画開始
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		switch( iSceneStatus )
		{
		case SCENE.INIT:
			//初期化
			break;
		case SCENE.START:
			//開始
			system_draw( );

			SeneStart_draw( );
			break;
		case SCENE.MAIN:
			//メイン
			system_draw( );
			break;
		case SCENE.CLEAR:
			//クリア
			system_draw( );
			SeneClear_draw( );
			break;
		case SCENE.END:
			//ゲームーバー
			system_draw( );
			SeneEnd( );
			break;
		case SCENE.PAUSE:
			//一時停止
			system_draw( );
			pause_draw( );
			break;
		case SCENE.RELESE:
			//後処理
			break;
			
			
		case SCENE.EXIT:
		default:
			break;
		}
// for debug code start
Hell_drawFPS( 550, 10 );
//Hell_drawFont( std.string.toString( cast( int )scroll_status ), 10, 10 * 1, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )position.y ), 10, 10 * 2, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )place ), 10, 10 * 3, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )motion ), 10, 10 * 4, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )debug_disp[0] ), 10, 10 * 5, 1 , 255,255,255 );
//Hell_drawFont( std.string.toString( cast( int )jump_fream_count ), 10, 10 * 6, 1 , 255,255,255 );
// for debug code end

	}
	
	// 画面サイズ取得
	int getScreenWidth(){return boot.g_width;}
	int getScreenHeight(){return boot.g_height;}
	
	string zfill(string str , int n)
	{
		for(int t=str.length;t<n;t++){
			str = "0" ~ str;
		}
		return str;
	}
	
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの処理 #20A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_move( )
	{
		int j;
		//残り時間のカウント
		game_time_count--;
		for ( j = 0; j <= (card_max - 1); j++ )					//カードの表示
		{
			card[j].wait--;
		}

		//カードの移動
		card_move ();

		if (keypad.isPressUp())			//コマンド↑
		{
		} 

		if (keypad.isPressDown())		//コマンド↓
		{
		} 

		if (keypad.isPressRight())		//コマンド→
		{
		} 

		if (keypad.isPressLeft())		//コマンド←
		{
		} 

		if(keypad.isPushEnter())		//1ボタン
		{
		}
		
		if(keypad.isPushCancel())		//2ボタン
		{
		}
		
		if (Hell_isPushJButton(2,0))	//3ボタン　キーボードの割り当てがわからん(汗
		{
//			Hell_playWAV( "door", 0, -1 );
		}

		if(Hell_isPushMouse() & HELL_BUTTON_LEFT)	//マウス左クリック
		{
			card_lock();
		}
		
			if ( ( card_count == card_max ) || ( game_time_count <=0 ) || ( game_end == 0 ) )
		{
			
			Hell_playBgm( "resource/sound/results.ogg", 1, 0 );

			//ハイスコアの保存
//			game_score = game_time_count;
			if ( ( hi_score[0] < game_score ) && ( mode == 0 ) )
			{
				keypad.save( "replay/replay_00.bin" );	//リプレイの保存
				hi_score[0] = game_score;
				savedata.set("HI_SCORE",   cast(int)hi_score[0]);
				savedata.write();
			}
			if ( ( hi_score[1] < game_score ) && ( mode == 1 ) )
			{
				keypad.save( "replay/replay_01.bin" );	//リプレイの保存
				hi_score[1] = game_score;
				savedata.set("HI_SCORE1",   cast(int)hi_score[1]);
				savedata.write();
			}
			if ( ( hi_score[2] < game_score ) && ( mode == 2 ) )
			{
				keypad.save( "replay/replay_02.bin" );	//リプレイの保存
				hi_score[2] = game_score;
				savedata.set("HI_SCORE2",   cast(int)hi_score[2]);
				savedata.write();
			}
			if ( ( hi_score[3] < game_score ) && ( mode == 3 ) )
			{
				keypad.save( "replay/replay_03.bin" );	//リプレイの保存
				hi_score[3] = game_score;
				savedata.set("HI_SCORE3",   cast(int)hi_score[3]);
				savedata.write();
			}
			if ( ( hi_score[4] < game_score ) && ( mode == 4 ) )
			{
				keypad.save( "replay/replay_04.bin" );	//リプレイの保存
				hi_score[4] = game_score;
				savedata.set("HI_SCORE4",   cast(int)hi_score[4]);
				savedata.write();
			}
			if ( ( hi_score[5] < game_score ) && ( mode == 5 ) )
			{
				keypad.save( "replay/replay_05.bin" );	//リプレイの保存
				hi_score[5] = game_score;
				savedata.set("HI_SCORE5",   cast(int)hi_score[5]);
				savedata.write();
			}
			if ( ( hi_score[6] < game_score ) && ( mode == 6 ) )
			{
				keypad.save( "replay/replay_06.bin" );	//リプレイの保存
				hi_score[6] = game_score;
				savedata.set("HI_SCORE6",   cast(int)hi_score[6]);
				savedata.write();
			}

			iSceneStatus = SCENE.CLEAR;
		}
		
		if ( iSceneStatus == SCENE.MAIN )
		{
			if(keypad.isPushCancel(true))
			{
//				//ポーズ
//				iSceneStatus = SCENE.PAUSE;
//				menu_input = 0;
			}
		}
	}
	void card_move( )
	{
			int j;
			int k;
		for ( j = 0; j <= (card_max - 1); j++ )					//カードの移動
		{
			if ( card[j].state == 0 )
			{
				//移動座標確認
				card[99].x = card[j].x + ( Hell_cosEx( card[j].deg ) * card[j].speed );
				card[99].y = card[j].y + ( Hell_sinEx( card[j].deg ) * card[j].speed );
			
				//外枠
				if ( card[99].x < 0 )
				{
					card[j].deg = ( -( card[j].deg - 180 )  + 0 ) % 360;
				}
				if ( card[99].x > 300 )
				{
					card[j].deg = ( -( card[j].deg - 0 )  + 180 ) % 360;
				}
				if ( card[99].y < 0 )
				{
					card[j].deg = ( -( card[j].deg - 270 )  + 90 ) % 360;
				}
				if ( card[99].y > 300 )
				{
					card[j].deg = ( -( card[j].deg - 90 )  + 270 ) % 360;
				}

//				for ( k = 0; k <= card_max - 1; k++ )				//カード衝突判定 (簡易)
//				{
//					if ( ( card[j].x - 32 < card[k].x ) && ( card[j].x + 32 > card[k].x )
//					  && ( card[j].y - 32 < card[k].y ) && ( card[j].y + 32 > card[k].y ) && ( k != j )  )
//					{
//						card[j].deg = card[j].deg + 180 ;			
//						k = 39;										//リセット
//					}
//				}
			
				card[j].x = card[j].x + ( Hell_cosEx( card[j].deg ) * card[j].speed );
				card[j].y = card[j].y + ( Hell_sinEx( card[j].deg ) * card[j].speed );
		
			}
		}
	}
	void card_lock( )
	{
		int j;
		int k;
		int count_l0 = 0;
		int count_l1 = 0;
		
		for ( j = 0; j <= (card_max - 1); j++ )					//クリックで2枚以上重ならないか確認
		{
			if ( ( Hell_getMouseX - 32 - field_x < card[j].x  ) && ( Hell_getMouseX + 0 - field_x > card[j].x )
			  && ( Hell_getMouseY - 32 - field_y < card[j].y  ) && ( Hell_getMouseY + 0 - field_y > card[j].y ) 
			  && ( card[j].state < 2 ) )
			{
				if ( card[j].state == 0 )
				{
					count_l0++;
				}
				if ( card[j].state == 1 )
				{
					count_l1++;
				}
			}
		}
		if ( ( count_l0 == 1 ) && ( count_l1 == 0 ) && ( cardlock1 != 99 ) )
		{
			for ( j = 0; j <= (card_max - 1); j++ )				//２枚目カードのlock
			{
				if ( ( Hell_getMouseX - 32 - field_x < card[j].x  ) && ( Hell_getMouseX + 0 - field_x > card[j].x )
				  && ( Hell_getMouseY - 32 - field_y < card[j].y  ) && ( Hell_getMouseY + 0 - field_y > card[j].y )  
				  && ( card[j].state < 2 ) )
				{
					if ( card[j].wait > 0 )
					{
//					Hell_playWAV( "select", 0, -1 );
					card[j].state = 1;
					cardlock2 = j;
					}
//					else
//					{
//					Hell_playWAV( "select", 0, -1 );		//前のカードの解除と新しいカードのロック110925
//					card[cardlock1].state = 0;				//操作ミスしやすいので不採用！
//					card[cardlock1].wait =  wait_time;
//					cardlock2 = 99;
//					card[j].state = 1;
//					cardlock1 = j;
//					}
				}
			}
		}
		if ( ( count_l0 == 1 ) && ( count_l1 == 0 ) && ( cardlock1 == 99 ) )
		{
			for ( j = 0; j <= (card_max - 1); j++ )				//１枚目カードのlock
			{
				if ( ( Hell_getMouseX - 32 - field_x < card[j].x  ) && ( Hell_getMouseX + 0 - field_x > card[j].x )
				  && ( Hell_getMouseY - 32 - field_y < card[j].y  ) && ( Hell_getMouseY + 0 - field_y > card[j].y ) 
				  && ( card[j].state < 2 ) )
				{
					if ( card[j].wait > 0 )
					{
					Hell_playWAV( "select", 0, -1 );		//1枚目のロック
					card[j].state = 1;
					cardlock1 = j;
					cardlock2 = 99;
					}
					else
					{
					Hell_playWAV( "powerup", 0, -1 );		//捲り
					card[j].state = 0;
					card[j].wait = wait_time;
					cardlock1 = 99;
					cardlock2 = 99;
					}
				}
			}
		}
		if (( count_l0 == 0 ) && ( count_l1 == 1 ) && ( ( Hell_getMouseX - 32 - field_x < card[cardlock1].x  ) && ( Hell_getMouseX + 0 - field_x > card[cardlock1].x )
				  && ( Hell_getMouseY - 32 - field_y < card[cardlock1].y  ) && ( Hell_getMouseY + 0 - field_y > card[cardlock1].y ) ) )			//カードのlock解除
		{
					Hell_playWAV( "cancel", 0, -1 );			//１枚目カードのlock解除
					card[cardlock1].state = 0;
					card[cardlock1].wait = wait_time;
					cardlock1 = 99;
					cardlock2 = 99;
		}
		if ( ( cardlock1 != 99 ) && ( cardlock2 != 99 ) )		//得点加算へ
		{
			if ( ( card[cardlock1].num == card[cardlock2].num ) || ( card[cardlock1].type == card[cardlock2].type ) )
			{
				Hell_playWAV( "get", 0, -1 );
				card_point();
			}
			else												//110426役ができないカードを裏返しにする仕様
			{
				Hell_playWAV( "miss", 0, -1 );
				card[cardlock1].state = 0;
				card[cardlock1].wait = 0;
				cardlock1 = 99;
				card[cardlock2].state = 0;
				card[cardlock2].wait = 0;
				cardlock2 = 99;

				bg_r2 = 100;
				bg_g2 = 100;
				bg_b2 = 100;

			}
		}
	}
	void card_point( )
	{
		int j;
		int count[15] = 0;
		
		bonus = cast(int)( ( game_time_count + 59) / 60 )  ;
		bonus1 = 1;
		bonus_n = 0;
		bonus_c = 0;
	if ( card[cardlock1].num == card[cardlock2].num )		//同数字は３倍
		{
		card[90].num = card[cardlock1].num;
		bonus1 = bonus1 * 3;
		}
		else
		{
		card[90].num = 999;		
		}
	if ( card[cardlock1].type == card[cardlock2].type )		//同色は２倍
		{
		card[90].type = card[cardlock1].type;		
		bonus1 = bonus1 * 2;
			if ( card[90].type == 0 )
			{
				bg_r2 = 150;
				bg_g2 = 0;
				bg_b2 = 0;
			}
			if ( card[90].type == 1 )
			{
				bg_r2 = 0;
				bg_g2 = 150;
				bg_b2 = 0;
			}
			if ( card[90].type == 2 )
			{
				bg_r2 = 150;
				bg_g2 = 150;
				bg_b2 = 0;
			}
		}
		else
		{
		card[90].type = 4;		
				bg_r2 = 0;
				bg_g2 = 0;
				bg_b2 = 100;
		}
		if ( ( card[cardlock1].num == card[cardlock2].num ) 
	      && ( card[cardlock1].type == card[cardlock2].type ) ) //同色＋同数字は更に３倍で12倍
		{
		bonus1 = bonus1 * 2;
		}
		//カードの消去
		card[cardlock1].state = 2;
		card[cardlock2].state = 2;
		cardlock1 = 99;
		cardlock2 = 99;
		card_count = card_count + 2;

		game_end = 0;
		for ( j = 0; j <= (card_max - 1); j++ )
		{
			if ( card[j].state < 2 )
			{
				count[card[j].num]++;		;	//0-9
				count[card[j].type+10]++;		//10-13
			}
		}
		for ( j = 0; j <= 13; j++ )
		{
			if ( count[j] >= 2 )
			{
				game_end++;						//可能な2枚組があればプラス
			}
		}
		
		
		
		//コンボスロットのスライド
		card[91].num = card[92].num;		
		card[92].num = card[93].num;		
		card[93].num = card[90].num;		
		card[91].type = card[92].type;		
		card[92].type = card[93].type;		
		card[93].type = card[90].type;		
		//コンボボーナス
		if ( ( card[91].num != 999 ) && ( card[92].num != 999 ) && ( card[93].num != 999 ) )
		{
			//同数字３連続は＋3333点 ゾロ目
			if ( ( card[91].num == card[92].num ) && ( card[91].num == card[93].num ) )
			{
			bonus_n = bonus_n + 3333; //number
			bonus_number = bonus_number + bonus_n;
			}
			//階段３連続は＋1000点
			if ( ( ( card[91].num - card[92].num +10 ) % 10) == ( ( card[92].num - card[93].num +10) % 10) )
			{
				if ( std.math.abs( card[91].num - card[92].num ) <= std.math.abs(card[92].num - card[93].num ) )
				{
					bonus_n = bonus_n + ( std.math.abs(card[91].num - card[92].num ) ) * 1000; 	//3step
				}
				else
				{
					bonus_n = bonus_n + ( std.math.abs(card[92].num - card[93].num ) ) * 1000; 	//3step
				}
			bonus_step = bonus_step + bonus_n;
			}
			//ビットボーナス＋6400点
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 1 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 2 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 4 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 8 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 16 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 32 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 64 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 128 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 256 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( ( card[91].num * 100 + card[92].num * 10 + card[93].num * 1 ) == 512 )
			{
			bonus_n = bonus_n + 6400; //number
			}
			if ( bonus_n == 6400 )
			{
			bonus_8bit = bonus_8bit + 6400; 
			}
		}
		if ( card[91].type != 4 )
		{
			if ( ( card[91].type == card[92].type ) && ( card[91].type == card[93].type ) )	//同色３連続は＋1000点
			{
			bonus_c = bonus_c + 1000;	//coler
			bonus_color = bonus_color + bonus_c;
			}
			if ( ( card[91].type != card[92].type ) && ( card[91].type + card[92].type + card[93].type ) == 3 )
			{
			bonus_c = bonus_c + 2000;	//signal
			bonus_signal = bonus_signal + bonus_c;	
			}
		}
		
		game_score = game_score + bonus * bonus1 + bonus_n + bonus_c; 

		effect_c[ card_count/2 - 1 ] = bonus_c;		//ボーナスエフェクト設定
		effect_n[ card_count/2 - 1 ] = bonus_n;
		effect_deg[ card_count/2 - 1 ] = Hell_randInt(0, 360);
		
	}
	//-----------------------------------------------------------------------------
	//	ゲーム情報、システムの描画 #20B
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//1	戻り値: なし
	//-----------------------------------------------------------------------------
	void system_draw( )
	{
		int min;
		int sec;
		int msec;
		char[] str;
		int r = 255;
		int g = 255;
		int b = 255;
		int j;
		int k;
		int c2 = 0;
		int combo_y = 150;
		int lock_y = -100;
		

		if ( bg_r < bg_r2)
		{
			bg_r = bg_r + 2;
		}else if ( bg_r > bg_r2)
		{
			bg_r = bg_r - 2;
		}
		if ( bg_g < bg_g2)
		{
			bg_g = bg_g + 2;
		}else if ( bg_g > bg_g2)
		{
			bg_g = bg_g - 2;
		}
		if ( bg_b < bg_b2)
		{
			bg_b = bg_b + 2;
		}else if ( bg_b > bg_b2)
		{
			bg_b = bg_b - 2;
		}
		
		Hell_drawRect( 10, 10,
					640 -10, 480 -10,
					0, 0, 
					bg_r, bg_g, bg_b, 
					255);							//前画面枠
		Hell_drawRect( field_x, field_y,
					300 + 32, 300 + 32,
					0, 0, 
					0,0,0, 
					255);							//フィールド枠
		
		Hell_setAlpha(HELL_ALPHA_NORMAL);

		Hell_drawFont( "SCORE" , 400, 80 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( game_score ) , 410, 110 , 4 , 255,255,255);

		Hell_drawFont( "HI SCORE" , 400, 10 , 2 , 255,255,255);
		Hell_drawFont( std.string.toString( hi_score[mode] ) , 410, 30 , 4 , 255,255,255);
	
		
	for ( j = 0; j <= (card_max - 1); j++ )					//カードの表示
	{
		if ( ( card[j].state == 0 ) && ( card[j].wait > 0 ) )//カードfree状態表示
		{
		Hell_drawTexture("tama"
			, card[j].x + field_x
			, card[j].y + field_y
			, 64 + card[j].type * 32
			, 32
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 180 );
		Hell_drawFont( std.string.toString( card[j].num ) 
			,cast(int)card[j].x + 8 + field_x
			, cast(int)card[j].y + 8 + field_x
			,2 
			, 255 / 4 * ( card[j].num % 4 + 1)
			, 255 / 3 * ( card[j].num % 3 + 1)
			, 255 / 2 * ( card[j].num % 2 + 1));
		}
		if ( ( card[j].state == 0 ) && ( card[j].wait<= 0 ) )//カード裏 状態表示
		{
		Hell_drawTexture("tama"
			, card[j].x + field_x
			, card[j].y + field_y
			, 64 + 4 * 32
			, 32
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 180 );
		}

		if ( card[j].state == 1 )							//カードlock状態表示
		{
		Hell_drawTexture("tama"
			, card[j].x + field_x
			, card[j].y + field_y
			, 64 + card[j].type * 32
			, 32
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("tama"				//ロック枠
			, card[j].x + field_x
			, card[j].y + field_y
			, 96
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 200 );
		Hell_drawFont( std.string.toString( card[j].num ) 
			,cast(int)card[j].x + 8 + field_x
			, cast(int)card[j].y + 8 + field_x
			,2 
			, 255 / 4 * ( card[j].num % 4 + 1)
			, 255 / 3 * ( card[j].num % 3 + 1)
			, 255 / 2 * ( card[j].num % 2 + 1));
		}

		if ( ( Hell_getMouseX - 32 - field_x < card[j].x  ) && ( Hell_getMouseX + 0 - field_x > card[j].x )
		  && ( Hell_getMouseY - 32 - field_y < card[j].y  ) && ( Hell_getMouseY + 0 - field_y > card[j].y )
		  && ( card[j].state == 0 ) )
		{						//マウスフォーカスのカーソル
		Hell_drawTexture("tama"
			, card[j].x + field_x
			, card[j].y + field_y
			, 64
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		}
		
	}
		Hell_drawRect( 440, 185 + combo_y,
					120 , 56,
					0, 0, 
					0, 100, 100, 
					255);							//combo枠
		Hell_drawRect( 444, 189 + combo_y,
					112 , 48,
					0, 0, 
					0, 0, 0, 
					255);							//combo枠

		Hell_drawFont( "COMBO BOX" , 445, 180  + combo_y, 1.5 , 255,100,100);
		for ( k = 1; k <= 3; k++ )					//comboの表示
		{
		Hell_drawTexture("tama"
			, 417 + k*34
			, 200 + combo_y
			, 32 * (card[k + 90].type + 2) 
			, 32
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
			if ( card[k + 90].num < 10)
			{
			Hell_drawFont( std.string.toString( card[k + 90].num ) , 
				417 + 8 + k * 34
				, 200 + 8  + combo_y
				, 2 
				, 255 / 4 * ( card[k + 90].num % 4 + 1)
				, 255 / 3 * ( card[k + 90].num % 3 + 1)
				, 255 / 2 * ( card[k + 90].num % 2 + 1));
			}
		}

	for ( j = 0; j <= (card_max - 1); j++ )					//combo表示
	{
		if ( ( card[j].state >= 2 ) && ( card[j].state <= 32 ) )		//カードeffect表示
		{
		Hell_drawTexture("tama"
			, card[j].x + field_x - card[j].state 
			, card[j].y + field_y - card[j].state 
			, 64 + card[j].type * 32
			, 32
			, 32, 32
			, 1.0 +(cast(float)card[j].state)/16 , 1.0+(cast(float)card[j].state)/16
			, 10 * card[j].state
			,255, 255, 255, 255 - card[j].state * 5 );
		Hell_drawFont( std.string.toString( card[j].num ) 
			,cast(int)card[j].x + 8 + field_x - card[j].state/2
			, cast(int)card[j].y + 8 + field_x - card[j].state/2
			,2 +(cast(float)card[j].state)/8
			, 255 / 4 * ( card[j].num % 4 + 1)
			, 255 / 3 * ( card[j].num % 3 + 1)
			, 255 / 2 * ( card[j].num % 2 + 1));
			card[j].state++;
			star_draw( card[j].x , card[j].y , card[j].state, card[j].deg );
			star_draw( 417 + 3 *34 -field_x , 200 + combo_y - field_y , card[j].state, card[j].deg );

			str = std.string.format( "%03d", bonus  );			//加点基準表示
			Hell_drawFont( str , 470, 210 - ( card[j].state / 2 ) , 2 , 180,180,180);
			str = std.string.format( "x%02d", bonus1 );			//加算ボーナス
			Hell_drawFont( str , 470 + 50 , 210 - ( card[j].state / 2 ) , 2 ,210,210,210);

			Hell_drawFont( "POINT" , 430, 170 - ( card[j].state / 2 ) , 2 ,255,255,0);
			Hell_drawFont( "+" , 480 -20, 190 - cast(int)( card[j].state /2 )  , 2 ,255,255,0);
			Hell_drawFont( std.string.toString( bonus * bonus1 ) , 480 , 190 - cast(int)( card[j].state /2 ), 2 ,255,255,0);

			if ( bonus_c > 999 )		//色BONUS表示
			{
				if ( bonus_c == 1000 )
				{
					Hell_drawFont( "COLOR" , 430, 240 - ( card[j].state / 2 ) , 2 ,255,100,100);
				}
				if ( bonus_c == 2000 )
				{
					Hell_drawFont( "SIGNAL" , 430, 240 - ( card[j].state / 2 ) , 2 ,255,100,100);
				}
			str = std.string.format( "+%04d" , bonus_c );
			Hell_drawFont( str , 450, 260 - ( card[j].state / 2 ) , 2 ,255,100,100);
			c2 = 50;
			}
			if ( bonus_n > 999 )		//数字BONUS表示
			{
				if ( ( bonus_n == 1000 ) 
				  || ( bonus_n == 2000 )
				  || ( bonus_n == 3000 )
				  || ( bonus_n == 4000 )
				  || ( bonus_n == 5000 ) )
				{
					Hell_drawFont( "STEP " , 430, 240 - ( card[j].state / 2 )+ c2 , 2 ,100,255,100);
				}
				if ( bonus_n == 3333 )
				{
					Hell_drawFont( "NUMBER" , 430, 240 - ( card[j].state / 2 )+ c2 , 2 ,100,255,100);
				}
				if ( bonus_n == 6400 )
				{
					Hell_drawFont( "8 BIT" , 430, 240 - ( card[j].state / 2 )+ c2 , 2 ,100,255,100);
				}
			str = std.string.format( "+%04d" , bonus_n );
			Hell_drawFont( str , 450, 260 - ( card[j].state / 2 ) + c2 , 2 ,100,255,100);
			}

	}
		

		
		if ( cardlock1 != 99 )						//選択カードの表示１
		{
		Hell_drawRect( 440, 285 + lock_y,
					120 , 116,
					0, 0, 
					0, 100, 100, 
					255);							//選択カード枠
		Hell_drawRect( 444, 289 + lock_y,
					112 , 108,
					0, 0, 
					0, 0, 0, 
					255);							//選択カード枠
		Hell_drawTexture("tama"
			, 452
			, 295 + lock_y
			, 64 + card[cardlock1].type * 32
			, 32
			, 32, 32
			, 3.0 , 3.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawFont( std.string.toString( card[cardlock1].num ) , 
			452 + 24 , 295 + 24 + lock_y,
			6 
			, 255 / 4 * ( card[cardlock1].num % 4 + 1)
			, 255 / 3 * ( card[cardlock1].num % 3 + 1)
			, 255 / 2 * ( card[cardlock1].num % 2 + 1));
		}
		if ( cardlock2 != 99 )								//選択カードの表示２ いらんけどさdebug
		{
		Hell_drawTexture("tama"
			, 550
			, 295 + lock_y
			, 64 + card[cardlock2].type * 32
			, 32
			, 32, 32
			, 3.0 , 3.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawFont( std.string.toString( card[cardlock2].num ) , 
			550 + 24 , 295 + 24 + lock_y,
			6 
			, 255 / 4 * ( card[cardlock2].num % 4 + 1)
			, 255 / 3 * ( card[cardlock2].num % 3 + 1)
			, 255 / 2 * ( card[cardlock2].num % 2 + 1));
		}
		
	}

		//debug Disp
//		Hell_drawFont( std.string.toString( Hell_GetGameflag(10) ) , 400, 200, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( card[0].deg ) , 400, 200, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( Hell_getMouseX ) , 400, 220, 2 , 255,255,255);
//		Hell_drawFont( std.string.toString( Hell_getMouseY ) , 450, 220, 2 , 255,255,255);

		min = ( game_time_count / 60 ) / 60;
		sec = ( game_time_count / 60 ) % 60;
		msec = game_time_count % 60;
		
		if ( iSceneStatus != SCENE.CLEAR )
		{
			str = std.string.format( "TIME %02d:%02d:%02d", min, sec, msec );			//time表示
			Hell_drawFont( str , 50, 30 , 2 , r,g,b);
			str = std.string.format( "%03d", cast(int)( (game_time_count + 59) / 60 ) );	//加点基準表示
			Hell_drawFont( str , 330, 30 , 2 , 255,255,0);
		}
		bonus_effect();
		
	}
	void star_draw( float sx , float sy ,int size , int deg )		//カードエフェクトの★
	{
		int j;
		for ( j = 0 ; j <= 12 ; j++ )
		{
		Hell_drawTexture("tama"
			, sx + field_x + 16 -2 + ( Hell_cosEx( j * 40 - size * 4 + deg ) ) * size 
			, sy + field_y + 16 -2 + ( Hell_sinEx( j * 40 - size * 4 ) ) * size 
			, 128 
			, 0
			, 4, 4
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
			if ( game_score > 30000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 30 + size * 4 + deg ) ) * size * 1.5
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 30 + size * 4 ) ) * size * 1.5
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
			if ( game_score > 60000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 30 - size * 4 ) ) * size * 2
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 30 - size * 4 + deg ) ) * size * 2
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
			if ( game_score > 90000 )
			{
			Hell_drawTexture("tama"
				, sx + field_x + 16 -2 + ( Hell_cosEx( j * 20 - size * 4 ) ) * size * 2
				, sy + field_y + 16 -2 + ( Hell_sinEx( j * 20 - size * 4 ) ) * size * 2
				, 128 
				, 0
				, 4, 4
				, 1.0 , 1.0
				, 0
				,255, 255, 255, 255 );
			}
		}
	}
	void 	bonus_effect( )					//ボーナスエフェクト★ 110430ココが最終頑張りライン
	{
		int j;
		int size_b;
		int eff_y;
		for ( j = 0 ; j <= 30 -1 ; j++ )
		{
			if ( (effect_count[j] < 60 ) && ( effect_c[j] > 0 ) )
			{
				if ( effect_c[j] == 1000 )	//COLOR
				{
					eff_y = 0;
				}
				if ( effect_c[j] == 2000 )	//SIGNAL
				{
					eff_y = 1;
				}
				size_b = effect_count[j] / 5;
				Hell_drawTexture("tama"
					, field_x + 332/2 - size_b * 8 + ( Hell_cosEx( effect_deg[j] ) * ( effect_count[j] + 5 ) * 2 )
					, field_y + 332/2 - size_b * 8 + ( Hell_sinEx( effect_deg[j] ) * ( effect_count[j] + 5 ) * 2 )
					, 16 * ( 2 - game_time_count / 10 % 3)
					, 96 + 16 * eff_y
					, 16, 16
					, size_b , size_b
					, 0
					,255, 255, 255, 255 - effect_count[j] * 3 );
			}
			if ( (effect_count[j] < 60 ) && ( effect_n[j] > 0 ) )
			{
				if ( effect_n[j] == 3333 )		//NUMBER
				{
					eff_y = 2;
				}
				if ( effect_n[j] % 1000 == 0 )	//STEP 1000 2000 3000 4000 5000
				{
					eff_y = 3;
				}
				if ( effect_n[j] == 6400 )		//8Bit
				{
					eff_y = 4;
				}
				size_b = effect_count[j] / 5;
				Hell_drawTexture("tama"
					, field_x + 332/2 - size_b * 8 - ( Hell_cosEx( effect_deg[j] ) * ( effect_count[j] + 5 ) * 2 )
					, field_y + 332/2 - size_b * 8 - ( Hell_sinEx( effect_deg[j] ) * ( effect_count[j] + 5 ) * 2 )
					, 16 * ( 2 - game_time_count / 10 % 3)
					, 96 + 16 * eff_y
					, 16, 16
					, size_b , size_b
					, 0
					,255, 255, 255, 255 - effect_count[j] * 3 );
			}
			if ( (effect_count[j] < 60 ) && ( ( effect_c[j] + effect_n[j] ) > 0 ) )
			{
				effect_count[j] ++;
				effect_deg[j] = effect_deg[j] + 3;
			}
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの処理   #09A
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_move( )
	{
		if(keypad.isPushUp(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input++;
			if ( menu_input > 1 )
			{
				menu_input = 0;
			}
		}
		else if(keypad.isPushDown(true))
		{
			Hell_playWAV( "select", 0, -1 );
			menu_input--;
			if ( menu_input < 0 )
			{
				menu_input = 1;
			}
		}
		if(keypad.isPushEnter(true))
		{
			switch ( menu_input )
			{
			case 0:
				//ポーズ解除
				iSceneStatus = SCENE.MAIN;
				break;
			case 1:
				//リトライ
				iSceneStatus = SCENE.RELESE;
				break;
			default:
				break;
			}
		}
		if(keypad.isPushCancel(true))
		{
			//ポーズ解除
			iSceneStatus = SCENE.MAIN;
		}
	}
	//-----------------------------------------------------------------------------
	//	ポーズの描画 #09B
	//-----------------------------------------------------------------------------
	//	引	数: なし
	//	戻り値: なし
	//-----------------------------------------------------------------------------
	void pause_draw( )
	{
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		Hell_drawTexture("menu"
			, 96 + 160
			, 64 + 120 + ( menu_input * 32 )
			, 320
			, 0
			, 32, 32
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
		Hell_drawTexture("menu"
			, 160
			, 120
			, 0
			, 0
			, 320, 240
			, 1.0 , 1.0
			, 0
			,255, 255, 255, 255 );
	}
	
	
}


