﻿/********************************************************************************/
/* 	state.d																		*/
/*------------------------------------------------------------------------------*/
/*	製作		瓦千鳥（あるふぁ～秘密基地）									*/
/*	製作開始	2011/04/15														*/
/*	MAIL		dij@estate.ocn.ne.jp											*/
/*	URL			http://maglog.jp/alpha-secret-base/								*/
/*																				*/
/*	このソースは「やわらかライセンス」の元で配布されています。					*/
/*-更新履歴---------------------------------------------------------------------*/
/*	2011/04/30	初版															*/
/*-その他-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/

/* ライブラリのインポート *******************************************************/
private import hell2;		// dHell2ライブラリ
private import vector;
private import keypad;
private import actor;
private import clickable;
private import gamecore;

private import std.string;
private import std.math;
private import std.math2;
private import std.stream;
private import std.thread;

import config;

/* グローバル定数定義 ***********************************************************/
GameState g_gamestate = null;


/* load *************************************************************************/
/*	リソースの読み込み															*/
/*-引数-------------------------------------------------------------------------*/
/*	なし																		*/
/*-返り値-----------------------------------------------------------------------*/
/*	なし																		*/
/********************************************************************************/
void load()
{
	Hell_loadTexture("font","resource/font/font.bmp" , [255,255,255]);
	Hell_loadTexture("menu","resource/image/menu.bmp" , [0,255,0]);
	Hell_loadWAV("select",        "resource/sound/select.wav");
	
	Hell_write("resource loaded.\n");
}

/* GameState ********************************************************************/
/*	ゲーム全体の状態遷移を管理するクラス										*/
/********************************************************************************/
class GameState
{
private:
	int msg;				// リクエストメッセージ
public:
	enum
	{
		MSG_NONE = 0,
		MSG_REQ_LOGO,			// ロゴ状態へ　行きたい
		MSG_REQ_TITLE,			// タイトル状態へ　行きたい
		MSG_REQ_GAME,			// ゲーム
		
		MSG_EXIT,				//アプリケーションの終了
	}
	
	void move(){}
	void draw(){}
	
	// 設定
	void setMsg(int m)
	{
		msg = m;
	}
	// 取得
	int getMsg()
	{
		return msg;
	}
}



bool loop()
{
	bool is_exit = true;	//アプリケーションの終了
	if(g_gamestate)
	{
		// メッセージ指示による状態遷移
		switch(g_gamestate.msg)
		{
			case GameState.MSG_NONE:
				break;
			case GameState.MSG_REQ_LOGO:
				g_gamestate = new LogoMain();
				break;
			case GameState.MSG_REQ_TITLE:
				g_gamestate = new TitleMain();
				break;
			case GameState.MSG_REQ_GAME:
				g_gamestate = new GameMain();
				break;
			case GameState.MSG_EXIT:
			default:
				is_exit = false;
				Hell_write("Unknown msg at loop.");
		}
	}
	else
	{
		// 初期状態
		g_gamestate = new LogoMain();
		Hell_write("Exec loop.\n");
	}
	
	g_gamestate.move();
	g_gamestate.draw();
	
	return( is_exit );
}

/* TitleMain ********************************************************************/
/*	タイトルの状態																*/
/********************************************************************************/

class TitleMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	ConfigParser savedata;			// セーブデータ
	int hi_score[10];
	int star;
	int maxstar;
	int sel ;
	
	this()
	{
Hell_write( "TitleMain\n" );
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		star = 0;

		keypad = new Keypad();
		//セーブデータ
		hi_score[0] = 0;
		savedata = new ConfigParser();
		try
		{
			savedata.load(CONFIG_PATH);
		}
		catch(Exception e)
		{
			savedata.set("HI_SCORE",         0);
			savedata.set("HI_SCORE1",         0);
			savedata.set("HI_SCORE2",         0);
			savedata.set("HI_SCORE3",         0);
			savedata.set("HI_SCORE4",         0);
			savedata.set("HI_SCORE5",         0);
			savedata.set("HI_SCORE6",         0);
			savedata.set("HOSHI",         1);
			savedata.set("SELECT_HOSHI",         0);
			savedata.write();
		}
		hi_score[0] = savedata.getint("HI_SCORE");
		hi_score[1] = savedata.getint("HI_SCORE1");
		hi_score[2] = savedata.getint("HI_SCORE2");
		hi_score[3] = savedata.getint("HI_SCORE3");
		hi_score[4] = savedata.getint("HI_SCORE4");
		hi_score[5] = savedata.getint("HI_SCORE5");
		hi_score[6] = savedata.getint("HI_SCORE6");
		maxstar = savedata.getint("HOSHI");
		star = savedata.getint("SELECT_HOSHI");
		
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
//			Hell_loadTexture("title","resource/image/title.bmp" , [0,255,0]);
//			Hell_playBgm( "resource/sound/title.ogg", -1, 0 );
			Hell_stopBgm( 1000 );
		}
		timer++;
		
		if ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) && ( Hell_GetGameflag(10) > 0 ) )
//		if(keypad.isPushEnter())		//１ボタン
		{
			setMsg(GameState.MSG_REQ_GAME);
		}
/*
		if(keypad.isPushCancel())		//2ボタン
		{
			savedata.set("SELECT_HOSHI",         star);
			savedata.write();

			Hell_SetGameflag( 0, 1 );	//リプレイモードON
			Hell_SetGameflag( 1, star );	//星番号
			setMsg(GameState.MSG_REQ_GAME);
		}
*/
		if(keypad.isPushLeft())
		{
		}
		else if(keypad.isPushRight())
		{
		}
	}
	
	void draw()
	{
		int min;
		int sec;
		int msec;
		char[] str;
		
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
/*	
		Hell_drawTexture("title"
			, 0
			, 0
			, 0
			, 0
			, 640 , 480
			, 1.0 , 1.0
			, 0 );
*/

		Hell_drawRect( 50, 50,
				540 , 400,
				0, 0, 
				0, 0, 100, 
				255);							//MENU枠

		Hell_drawFont( "Cross Card"  , 130, 130 , 5 , 255,255, 0);

		Hell_drawFont( "LINE   "  , 150, 210 , 3 , 255,255,255);
		Hell_drawFont( "SHUFFLE"  , 150, 240 , 3 , 255,255,255);
		Hell_drawFont( "MEMORY "  , 150, 270 , 3 , 255,255,255);
		Hell_drawFont( "SQUARE "  , 150, 300 , 3 , 255,255,255);
		Hell_drawFont( "MIXER  "  , 150, 330 , 3 , 255,255,255);
		Hell_drawFont( "REVERSE"  , 150, 360 , 3 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[1] );
		Hell_drawFont( str , 350, 210 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[2] );
		Hell_drawFont( str , 350, 240 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[3] );
		Hell_drawFont( str , 350, 270 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[4] );
		Hell_drawFont( str , 350, 300 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[5] );
		Hell_drawFont( str , 350, 330 , 2.5 , 255,255,255);
		str = std.string.format( "%06d" , hi_score[6] );
		Hell_drawFont( str , 350, 360 , 2.5 , 255,255,255);
		Hell_drawFont( "HI SCORE" , 360, 190 , 1.5 , 255,255,255);

		if ( ( Hell_getMouseX >150 ) && ( Hell_getMouseX <640-150 ) )
		{
			if ( ( Hell_getMouseY >210 ) && ( Hell_getMouseY <210+30 ) )
			{
				Hell_drawFont( "LINE   "  , 150, 210 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 1 );
			}else if ( ( Hell_getMouseY >240 ) && ( Hell_getMouseY <240+30 ) )
			{
				Hell_drawFont( "SHUFFLE"  , 150, 240 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 2 );
			}else if ( ( Hell_getMouseY >270 ) && ( Hell_getMouseY <270+30 ) )
			{
				Hell_drawFont( "MEMORY "  , 150, 270 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 3 );
			}else if ( ( Hell_getMouseY >300 ) && ( Hell_getMouseY <300+30 ) )
			{
				Hell_drawFont( "SQUARE "  , 150, 300 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 4 );
			}else if ( ( Hell_getMouseY >330 ) && ( Hell_getMouseY <330+30 ) )
			{
				Hell_drawFont( "MIXER  "  , 150, 330 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 5 );
			}else if ( ( Hell_getMouseY >360 ) && ( Hell_getMouseY <360+30 ) )
			{
				Hell_drawFont( "REVERSE"  , 150, 360 , 3 , 100,255,100);
				Hell_SetGameflag( 10 , 6 );
			}
			else
			{
				Hell_SetGameflag( 10 , 0 );
			}

			if ( Hell_GetGameflag(10) != sel )
			{
				sel = Hell_GetGameflag(10);
				if ( Hell_GetGameflag(10) > 0 )
				{
					Hell_playWAV( "select", 0, -1 );
				}
			}
		}
		
//		Hell_drawFont( std.string.toString(Hell_GetGameflag(10)) , 300, 30 , 4 , 255,255,255);
//		min = ( hi_score / 60 ) / 60;
//		sec = ( hi_score / 60 ) % 60;
//		msec = hi_score % 60;
//		str = std.string.format( "%02d:%02d:%02d", min, sec, msec );
//		Hell_drawFont( str , 300, 30 , 4 , 255,255,255);

		Hell_drawFont( "MENU CLICK TO START"  , 180, 400 , 2 , 255,255,255);

//		Hell_drawFont("HOGE" , 240, 160 , 4 , 255,255,255);
		Hell_drawFont("ALPHA SECRET BASE 2011" , 280, 480-20 , 2 , 255,255,255);
	}
}

/* TitleMain ********************************************************************/
/*	ロゴの状態																	*/
/********************************************************************************/

class LogoMain : GameState
{
public:
	int timer;
	Keypad keypad;					// キーボード/ゲームパッド取得用
	int init_flag;
	
	this()
	{
		setMsg( GameState.MSG_NONE );
		timer = 0;
		init_flag = 0;
		
		keypad = new Keypad();
//		menu = new ClickablePool();
//		menu.add("START" , new Vec3(280 , 400 , 0) , new Vec3(96 , 32 , 0));
		
	}
	
	void move()
	{
		if ( init_flag == 0 )
		{
			init_flag = 1;
			Hell_loadTexture("logo","resource/image/logo.bmp" , [0,255,0]);
		}
		timer++;
		
		if ( ( (Hell_isPushMouse() & HELL_BUTTON_LEFT) )|| ( timer > 180 ) )
		{
//			Hell_playBgm( "resource/sound/99.ogg" );
			setMsg(GameState.MSG_REQ_TITLE);
			//１ボタン
		}
	}
	
	void draw()
	{
		Hell_begin();
		resetPerspective();
		Hell_setAlpha(HELL_ALPHA_NORMAL);
		
		Hell_drawTexture("logo"
			, 160
			, 120
			, 0
			, 0
			, 320 , 320
			, 1.0 , 1.0
			, 0 );
				
	}
}

